<template>
  <div>
    <div id="record-wizard" class="py-10">
      <div class="flex justify-between items-center w-full mb-10">
        <h2 class="text-3xl font-semibold">{{ $t('recordaVoicePhrase') }}</h2>
        <div class="w-fit">
          <LoginButton />
        </div>
      </div>
      <div class="flex items-start flex-col lg:flex-row gap-x-20">
        <ol
          id="rw-steps"
          class="flex mb-4 flex-row lg:flex-col gap-x-5 sm:gap-x-2 gap-y-3 lg:gap-y-6 sm:justify-between w-full lg:w-auto flex-wrap"
        >
          <li
            v-for="(step, index) in steps"
            :key="index"
            :class="currentStep == index ? 'active' : ''"
            class="flex gap-x-1 lg:gap-x-3 items-center flex-col gap-y-1 lg:flex-row"
          >
            <span class="rw-step-marker bg-slate-300 flex items-center justify-center">
              <CdxIcon v-if="currentStep > index" :icon="cdxIconCheck" />
              <span v-else>{{ index + 1 }}</span>
            </span>
            <span>
              {{ step.name }}
            </span>
          </li>
        </ol>
        <div v-if="isAuthenticated" class="steps-container self-start w-full">
          <router-view
            class="rounded-xl shadow-[0px_8px_20px_rgba(0,0,0,0.17)] w-full mb-10"
            @can-go-to-next-step="allowGoingToNextStep()"
            @toggle-previous-btn="showPreviousButton = !showPreviousButton"
            @set-current-step="(step) => (currentStep = step)"
            @can-not-go-to-next-step="disallowGoingToNextStep()"
          ></router-view>

          <div class="flex items-center gap-x-2">
            <CdxButton
              v-if="currentStep != 0 && showPreviousButton"
              action="progressive"
              weight="quiet"
              size="large"
              @click="previousStep()"
            >
              <CdxIcon :icon="cdxIconArrowPrevious" />
              {{ $t('previousWord') }}
            </CdxButton>

            <CdxButton
              v-if="currentStep + 1 < steps.length"
              action="progressive"
              weight="primary"
              size="large"
              :disabled="!steps[currentStep].canGoToNextStep"
              @click="nextStep()"
            >
              {{ $t('nextWord') }}
              <CdxIcon :icon="cdxIconArrowNext" />
            </CdxButton>
          </div>
        </div>
        <div
          v-else
          class="w-full md:w-3/4 mx-auto bg-white shadow-md rounded-lg px-2 py-4 sm:p-6 flex flex-col justify-center items-center h-full"
        >
          <p class="xs:text-lg mb-4 text-center">{{ $t('loginInRequiredStatement') }}</p>
          <CdxButton
            action="progressive"
            class="items-center gap-x-2"
            weight="primary"
            @click="goToLogin()"
          >
            <CdxIcon :icon="cdxIconLogoWikimediaCommons" />{{ $t('wikimediaCommonLoginPhrase') }}
          </CdxButton>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { ref } from 'vue'
import { useRouter, useRoute } from 'vue-router'
import { onMounted } from 'vue'
import LoginButton from '../components/LoginButton.vue'
import { CdxButton, CdxIcon } from '@wikimedia/codex'
import {
  cdxIconArrowPrevious,
  cdxIconArrowNext,
  cdxIconCheck,
  cdxIconLogoWikimediaCommons,
} from '@wikimedia/codex-icons'
import VueCookies from 'vue-cookies'
import { useRecordWizardStore } from '@/stores/recordwizard'
import { useI18n } from 'vue-i18n'

const store = useRecordWizardStore()
const { tm } = useI18n()
const isAuthenticated = VueCookies.get('sessionid') || ''
const router = useRouter()
const route = useRoute()

const steps = ref([
  {
    route: 'record-wizard.locutor',
    name: tm('steps.locutor'),
    canGoToNextStep: false,
    nextStepAction: 'saveLocuter',
  },
  {
    route: 'record-wizard.language',
    name: tm('steps.language'),
    canGoToNextStep: false,
    previousStepAction: 'getLocutors',
  },
  {
    route: 'record-wizard.hardware-check',
    name: tm('steps.hardwareCheck'),
    canGoToNextStep: false,
  },
  { route: 'record-wizard.word-list', name: tm('steps.wordList'), canGoToNextStep: false },
  { route: 'record-wizard.record', name: tm('steps.record'), canGoToNextStep: false },
  { route: 'record-wizard.review', name: tm('steps.review'), canGoToNextStep: false },
])

const currentStep = ref(0)

onMounted(() => {
  window.addEventListener('beforeunload', (e) => {
    if (route.name !== steps.value[0].route)
      e.returnValue = 'Are you sure you want to discard all the changes?'
  })
  console.log(route.name)
  console.log(steps.value[currentStep.value].route)

  if (steps.value[currentStep.value].route !== route.name) router.push('/')
})
const showPreviousButton = ref(true)

function nextStep() {
  const nextAction = steps.value[currentStep.value].nextStepAction
  nextAction && store[nextAction]()
  router.push({ name: steps.value[++currentStep.value].route })
}

function previousStep() {
  router.push({ name: steps.value[--currentStep.value].route })
}

function allowGoingToNextStep() {
  steps.value[currentStep.value].canGoToNextStep = true
}

function disallowGoingToNextStep() {
  steps.value[currentStep.value].canGoToNextStep = false
}

function goToLogin() {
  window.location.replace(import.meta.env.VITE_HOST + '/oauth/login/mediawiki')
}
</script>

<style scoped>
.steps-container {
  flex-grow: 1;
}

#rw-steps {
  list-style: none;
  font-size: 16px;
  padding: 0px;
}

#rw-steps li {
  font-weight: 600;
}

.rw-step-marker {
  box-sizing: border-box;
  max-width: 30px;
  max-height: 30px;
  min-width: 30px;
  min-height: 30px;
  text-align: center;
  border-radius: 100%;
  color: white;
  font-weight: bold;
}

.rw-step-marker .cdx-icon {
  color: white;
}

#rw-steps li.active {
  color: #3366cc;
}
#rw-steps li.active .rw-step-marker {
  background-color: #3366cc;
}

#rw-steps li.active ~ li {
  font-weight: normal;
}
</style>
